poj 3126.Prime Path(bfs)

题目链接:http://poj.org/problem?id=3126
Prime Path
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题目大意:简单来说,就是有t组数据,然后给你两个四位的素数数 n 和 m 这两个数字不考虑前导0 的情况。然后每次你可以改变某一位上的数字,但是要求改变之后的数字也是素数,问至少几次 可以使n变成m 。 这个思路就有了,可以用bfs的思想。
看下我的代码 和注释,你们肯定会懂得。

#include <stdio.h>
#include <string.h>
#include <queue>
#include <algorithm>
using namespace std;
int vis[10001];            //数字的访问标记,因为访问过的数字 如果变回去的话 肯定增加了步数
int n,m;                //两个素数
int res;                //记录最后的结果
int pow(int a,int b)            //自己写的指数函数
{
    int res = 1;
    for (int i = 0; i < b ; i++ )
    {
        res *= a;
    }
    return res;
}
struct sta            
{
    int n;                //记录数字
    int count;            //记录变了几次
}num;
int check(int num)                //判断数字符不符合要求
{
    int flag = 0;
    int temp = (num / 2) + 1;
    if ( vis[num] == 1 || num > 9999 || num < 1000)            //如果访问过了 就直接跳出
        return 0; 
    for (int i = 2 ; i <= temp ; i++ )                //求这个数是不是素数
    {
        if ( num % i == 0 )
        {
            flag =1;
            break;
        }
    }
    if ( flag == 0 && vis[num] == 0 && num >= 1000 && num <= 9999)
    {
        return 1;
    }
    else 
    {
        return 0;
    }
}

void  bfs(sta s)
{
    queue <sta> q;
    s.count = 0;
    vis[s.n] = 1;
    q.push(s);            //刚开始的数字入队
    sta now,next;
    while (!q.empty())    
    {
        now = q.front();
        q.pop();    
        if (now.n == m )            //如果已经变化到结果,则退出
        {
            res = now.count;
            return ;
        }
        for (int i = 1 ; i <= 4 ; i++ )
        {
            for (int j = 0 ; j <= 9 ; j++ )
            {
                next.n = now.n -( (now.n/pow(10,i-1)) % 10 ) * pow(10,i-1) + pow(10,i-1)* j;  //将某一位的数字先变成0  之后再变成1,2,3,。。。相当于直接改变
                next.count = now.count + 1;                //步数增加
                if (check(next.n))                //如果符合要求,入队
                {

                    vis[next.n] = 1;
                    q.push(next);
                }
            }
        }
    }
    return ;
}

int main()
{
    int t;
    scanf("%d",&t);
    while ( t-- )
    {
        res = 0;
        memset(vis,0,sizeof(vis));            //每次输入都要初始化vis
        scanf("%d%d",&n,&m);
        num.n = n;
        num.count = 0;
        bfs(num);
        printf("%d\n",res);                //输出结果
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值